// assumed cols > rows, if not, turn pic 90 degree by yourself
// bar_data should seperate from comment chars, two_ends keep clean.
// input *.bmp, color_plate in 0~255 grey grades.
// MAX_pdf: 90 bar_code *34 block      ( PDF417 stardard, 2+30+2 )
// MAX_pixel:  4096*1024
#include <stdio.h>
#include <string.h>
#define UNINW   60                   // for background sharpness
#define dunin   20
#define n1    4096                   // max cols
#define n2    1024                   // max rows
#define n3      90                   // max bar_number
#define expixel 600                  // expand pic thresh.
unsigned char obits[n2][n1];         // raw data
unsigned char  bits[n2+1800][n1];    // processing pic + 1800 resize_pic
unsigned char  btmp[n2+1800][n1];    // temp array  + re_size_picture
unsigned char   bar[n3][n1];         // raw bar
unsigned char  sbar[n3][n1];         // adjust bar
unsigned char  tbar[n3][17*34+1];    // save bar
unsigned short    h[539],th[549];    // BMP head 27+512  raw,save head
#define  o      255                  // following is pdf417 left_right code
unsigned char h1[17]={o,o,o,o,o,o,o,o,0,o,0,o,0,o,0,0,0};
unsigned char h2[18]={o,o,o,o,o,o,o,0,o,0,0,0,o,0,o,0,0,o};
int work[n1],work1[n1];
int w2[n2];                          // y_dir: Sigma_I(bits[j+1][i]-bits[j][i])
int xbar[34];                        // x_dir: each block position
int ybar[n3],t99[n3];                // y_dir: each code  position
int bargap,total,nblock,jbar,ibar;   // jbar: n_line_code, ibar===17*nblock+1
int start;                           // sbar-->tbar,  0 0 0 start ... [cols]
int rows,cols,oldrows;
int u1,u2,v1,v2;                     // 1st corner position of pixel
int x1,x2,x3,x4,y1,y2,y3,y4;         // 2nd corner position of bits file
int uninw,w99,reduce;                // w99=uninw+40  (regard o begin )
float f1,f2,f3,fc;                   // f2: scale, f3: temp, fc: (slip)
FILE *fp,*fp1;
char sb[30],sf[30];                  // file name
int P=1;                             // display or not

corner(u,v,x,y,zx,zy)                // input: u,v; output: x,y
int u,v,zx,zy, *x,*y;                // zx,zy  4 corner direction
{
  int i,j,k,p,q,r,s,t;
  for(r=0;r<rows/2;r++)for(j=0;j<=r;j++)for(i=0;i<=r;i++)if(i+j==r){
    s=u+i*zx; t=v+j*zy;
    if(s<0)s=0; if(s>cols-1)s=cols-1;
    if(t<0)t=0; if(t>rows-1)t=rows-1;
    if(bits[t][s]>uninw){  k=0;
      for(q=0;q<5;q++)for(p=0;p<5;p++)if(bits[t+q*zy][s+p*zx]>uninw)k++;
      if(k>=22)goto l10;             // allowed apear 3 0 in 25 data
    }
  }
l10:                           // distance 3 pixel of corner. find X,Y edge
  s+=zx*3; t+=zy*3;
  for(j=0;j<5;j++){ r=t-j*zy;
    if(r<0 || r>rows-1)break; if(bits[r][s]<uninw)break; }
  for(i=0;i<5;i++){ q=s-i*zx;
    if(q<0 || q>cols-1)break; if(bits[t][q]<uninw)break; }
  *x=q+zx;  *y=r+zy;
}

alone()                            // delete alone pointer, need 2 times
{
  int i,j,k;
  for(k=0;k<2;k++){
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=bits[j][i];
    for(j=1;j<rows-1;j++)for(i=1;i<cols-1;i++){
      if(bits[j][i]){
        if((btmp[j][i-1]|btmp[j][i+1])==0)bits[j][i]=0;
        if((btmp[j-1][i]|btmp[j+1][i])==0)bits[j][i]=0;
      }
    }
  }
}

smooth(w,g,n)
int *w,*g,n;
{
  int i;
  for(i=0;i<n;i++)g[i]=w[i];
  for(i=1;i<n-1;i++)w[i]=(g[i-1]+g[i+1]+g[i]*2)/4;
}

#define j3   3                            // threshold, in pixel
adjustjbar(w,v)                           // w[jbar], row_num;  v[]~temp
int *w,*v;                                // jbar maybe changed
{                                         // adjust w[] row_num in +-1 twice
  int i,j,k,j1,s,t;
  float x;
//for(i=0;i<jbar;i++)printf("%2d %d_%d\n",i,w[i],w[i+1]-w[i]);
  j1=jbar-1;
//printf("y2,last ybar[]: %d %d\n",y2,w[j1]);       // aviod last false_line
  if(y2-w[j1]<j3 ){ jbar--;
  if(P)printf(" last_jbar adjusted\n");
  }
//printf("y1, 1st ybar[0]: %d %d\n",y1,w[0]);       // avoid  1st false_line
  if(w[0]-y1<j3 && v[0]>100){ jbar--;
  if(P)printf(" 1st_jbar adjusted\n");
    for(i=0;i<jbar;i++)w[i]=w[i+1];
  }
  j1=jbar-1;                                        // not delete this line!
  for(j=0;j<2;j++){                                 // do twice
    x=w[j1]-w[0]; x/=jbar; k=x+0.5;
    for(i=0;i<j1;i++)v[i]=w[i+1]-w[i];
// for(i=0;i<jbar;i++)printf("%2d %d_%d\n",i,w[i],v[i]); printf("\n");
// smooth 1st
    for(i=0;i<j1;i++)if(v[i]-k>j3){
      if(i==0){ w[1]--; continue; }
      if(i==j1-1){ w[j1-1]++; continue; }
      if(v[i+1]<v[i-1])w[i+1]--;
      if(v[i+1]>v[i-1])w[i]++;
    }
    for(i=0;i<j1;i++)v[i]=w[i+1]-w[i];
// delete false peek
    s=0; t=v[0]; for(i=1;i<j1;i++)if(v[i]<t){ t=v[i]; s=i; }
    if(k-t>=j3){
      if(v[s-1]>v[s+1])s++;
      for(i=s;i<j1;i++)w[i]=w[i+1]; jbar=j1; j1--;
      for(i=0;i<j1;i++)v[i]=w[i+1]-w[i];
    }
  }
//for(i=0;i<jbar;i++)printf("%2d %d_%d\n",i,w[i],v[i]);
}

// process a block data, a[w], f2:scale, b:temp, jbar,block:for_print
// delete small black point
// normal 4 segment B_W group; if more: up_level; if less: find V shape, set 0
expblock(a, w, f2, b, jbar, block)
int *a,w,*b,jbar,block; float f2;
{
  int i,j,j1,j2,k,k2,level=w99;  float f,x;
  for(i=0;i<w;i++)if(a[i]<level)a[i]=0;
// delete small black pointers.
l00:
  for(i=0;i<w;i++)b[i]=a[i];  b[w]=255;      // set last data 0's edge
  i=0;
l05:
  while(b[i]==0)i++; if(i>=w-3)goto l06;
  k=0; for(j=i;j<w;j++)if(b[j])k+=b[j]; else break;
                     if(j==w)goto l06;
  if(k<255)for(k=i;k<j;k++)a[k]=0;       // add energy <255, delete 2~3 point
  i=j;
  goto l05;
l06:
// check 00 apear 4 times;
  k=-1;
  j=0; for(i=0;i<w;i++)if(a[i]==0){ if(k==1){ j++; k=0;}} else k=1;
  if(j>4){   reduce++;
  if(P)printf("## %d_%d  ",jbar,block);              // up white level
//for(i=0;i<w;i++){printf("%4d",a[i]); if(i%20==19)printf("\n");} printf("\n");
    level+=20; if(level>180)return;
    for(i=0;i<w;i++)if(a[i]<level)a[i]=0;
    goto l00;
  }
  if(j<4){  reduce++;
  if(P)printf("** %d_%d  ",jbar,block);             // expand lost_zero;
//for(i=0;i<w;i++){printf("%4d",a[i]); if(i%20==19)printf("\n");} printf("\n");
    for(i=0;i<w;i++)b[i]=a[i];
    i=0;
l10:                                       // find left_0,  it's left must 255
    i++; if(i>=w)goto l15;
    if(b[i])goto l10;
    for(j=i-1;j>i-4;j--)if(j>=0)b[j]=255;
    for(j=i;j<w;j++)if(b[i])break; else b[i]=255; //right_0,  right (3) 255
    for(j=i;j<i+3;j++)b[j]=255;            // find  0  & left,right -->255
    i+=2; goto l10;
l15:
    k=b[2];
    for(i=3;i<w;i++)if(b[i]<k){ k=b[i]; j=i; }
    a[j-1]=a[j]=a[j+1]=0;                         // set 3 continue 0
//for(i=0;i<w;i++){printf("%4d",a[i]); if(i%20==19)printf("\n");} printf("\n");
  }
// expand small union 1 unit according scale
  i=0;
l20:
  i++; if(i>=w)return;
  if(a[i])goto l20;             // find 0
  j=i; while(a[i]==0)i++;       // find 1
  f=i-j; f/=f2; x=f;  while(f>1.)f-=1.;
  j1=j-1; j2=i;  k=(1.-f)*f2;
  if(k==0)goto l20;
  if(x<1.)goto l30;             // for signal mark
  if(x>2.)goto l20;             // enough word
  k2=f2/2.; if(k>k2)goto l20;
l30:
//  if(a[j1]>a[j2]){ a[j2]=0; i++;}  else a[j1]=0;
  if(k==1){ if(a[j1]>a[j2]){ a[j2]=0; i++;}  else a[j1]=0;  k--; }
  if(k>=2){ a[j1--]=a[j2++]=0; i++; k-=2; }
  if(k>0)goto l30; else goto l20;
}

expand2(int i1,int i2)            // expand pic to 2*2 times size.
{                                 // & sharpness background
  int i,j,k;
  for(j=0;j<rows;j++)for(i=i1;i<=i2;i++)btmp[j][i-i1]=bits[j][i];
  rows=rows*2-1; cols=(i2-i1)*2+1;  h[9]=cols; h[11]=rows;
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[j][i]=0;
  for(j=0;j<rows;j+=2)for(i=0;i<cols;i+=2)bits[j][i]=btmp[j/2][i/2];
  if(P)printf("PICsize changed: %d*%d\n",cols,rows);
  for(j=1;j<rows;j+=2)for(i=0;i<cols;i+=2)
                    bits[j][i]=(bits[j-1][i]>>1)+(bits[j+1][i]>>1);
  for(j=0;j<rows;j+=2)for(i=1;i<cols;i+=2)
                    bits[j][i]=(bits[j][i-1]>>1)+(bits[j][i+1]>>1);
  for(j=1;j<rows;j+=2)for(i=1;i<cols;i+=2){
      k=bits[j-1][i-1]+bits[j-1][i+1]+bits[j+1][i-1]+bits[j+1][i+1];
      bits[j][i]=k>>2;
  }                                              // use uninw sharpness
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(bits[j][i]<uninw)bits[j][i]=0;
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)obits[j][i]=255-bits[j][i];
}

exp170(a,w,jbar,block)
int *a,w,jbar,block;
{
  float f; int i,j,k;
  f=w/17.;
  for(i=0;i<17;i++){
    j=(i+0.5)*f;
    k=a[j];                                  //             v
//  if(k)if(a[j-1]==0 || a[j+1]==0)k=0;      // avoid   11001111
    if(k)if(a[j-1]==0 )k=0;      // avoid   11001111
    a[i]=k;
  }
}

exp17(a, w, jbar, block)              // if a block !=17 unit, adjust...
int *a,w,jbar,block;
{
  float f,b[8];  int i,j,k,m,d[9];    // 9 change_pointer, (+ next edge)
  f=17./w;  d[0]=0; d[8]=w;           // 1st sure be black, start from 2-5th
  for(j=1,i=5;i<w-5;i++){ if(a[i]!=a[i+1])d[j++]=i;  if(j==8)break; }
  for(j=0;j<9;j++)d[j]=d[j+1]-d[j];
  if(a[w-1])d[7]--;
  for(j=0;j<8;j++)b[j]=d[j]*f;
  for(j=i=0;j<8;j++){ d[j]=b[j]+0.5; i+=d[j]; }
  if(i!=17){  reduce++;
  if(P)printf("&& %d_%d  ",jbar,block);
    not17(b);  for(j=0;j<8;j++)d[j]=b[j]+0.5;
  }
//  for(i=k=m=0;i<8;i++){ m=255-m; for(j=0;j<d[i];j++)a[k++]=m; }
  exp170(a,w,jbar,block);
}

not17(float *a)                   // judge a block, if include 17 pointer
{
  int i,j,k,c[8];    float x,y;
//for(i=0;i<8;i++)printf("%5.2f ",a[i]); printf("\n");
// 1st, no code >6.
  for(i=0;i<8;i++)if(a[i]>6.){
    x=(a[i]-6.)/2.; if(i-1>=0)a[i-1]+=x; if(i+1<8)a[i+1]+=x;
  }
// 2nd, fill 1
  if(a[0]<1.){ a[1]-=(1.-a[0])/2.; a[0]=1.; }
  if(a[7]<1.){ a[6]-=(1.-a[7])/2.; a[7]=1.; }
  for(i=1;i<7;i++)if(a[i]<1.){
    x=(1.-a[i])/2.; a[i-1]-=x; a[i+1]-=x; a[i]=1.;
  }
  y=0.15; j=0;
l30:
  j++;
  for(i=0;i<8;i+=2){                        // back--, white++;
    k=a[i]; x=(a[i]-k)/2.;
    if(x>0. && x<y){ a[i]-=x+x; if(i-1>=0)a[i-1]+=x; if(i+1<8)a[i+1]+=x; }
  }
  for(i=0;i<8;i++)c[i]=a[i]+0.5;
  k=0; for(i=0;i<8;i++)k+=c[i];
//for(i=0;i<8;i++)printf("%5.2f ",a[i]); printf("  %d\n",k);
  if(k==17)return;
//  fill white;
  k=a[7]+0.5; x=(k-a[7])/2.;
  if(x>0 && x<y){ a[7]+=x+x; a[6]-=x; }
  for(i=1;i<=5;i+=2){
    k=a[i]+0.5; x=(k-a[i])/2.;
    if(x>0 && x<y){ a[i]+=x+x; a[i-1]-=x; a[i+1]-=x; }
  }
  for(i=0;i<8;i++)c[i]=a[i]+0.5;
  k=0; for(i=0;i<8;i++)k+=c[i];
//for(i=0;i<8;i++)printf("%5.2f ",a[i]); printf("  %d\n",k);
  if(k==17)return;
  if(j<4){ y+=0.05; goto l30; }               // loop, up threshold y a little
  return;
}

main(int ac, char **av)
{
  int i,j,k,u,v,w, i1,i2,j1,j2, ip=0;
  if(ac<2){
     printf("\n\t********** re_shape of pdf417 image **********\n");
     printf("\n\t                         jiang zhaoji 20110929\n");
     printf("\n\tUsage: re_shape  file*.[bmp] [!]\n");
     printf("\n\tex:    re_shape  i00");
     printf("\n\tex:    re_shape  i* !\n");
     printf("\n\toutput si*.bmp\n");
     printf("\n\t! means quiet, no display");
     printf("\n\tmark means: ## >4; ** <4; && !17\n\n");
     return 0;
  }
  if(ac>2)P=0;
  strcpy(sb,av[1]);  for(i=0;i<strlen(sb);i++)if(sb[i]=='.')sb[i]=0;
  sprintf(sf,"dir/b %s.bmp >re_shape.tmp",sb);  system(sf);
  fp1=fopen("re_shape.tmp","r");
l99:
  fgets(sf,30,fp1);
  if(feof(fp1)){ fclose(fp1); system("del re_shape.tmp"); return 0; }
  k=strlen(sf);  sf[k-1]=0;
  fp=fopen(sf,"rb"); if(fp==0){printf("\t %s file not found!\n",sf); goto l99;}
  fread(h,2,539,fp); for(i=0;i<539;i++)th[i]=h[i];
  if(h[14]!=8){ fclose(fp); printf("\t %s not 256 grey BMP!\n",sf); goto l99; }
  cols=h[9]; rows=h[11]; k=(cols+3)/4*4;
  if(cols>n1)cols=n1; if(rows>n2)rows=n2;      // only take n1*n2 max picture
  for(j=0;j<n2;j++)for(i=0;i<n1;i++)bits[j][i]=0;
  for(j=0;j<rows;j++)fread(&obits[rows-j-1][0],1,k,fp);  fclose(fp);
  if(P)printf("\n%d: =======  %s  size: %d*%d\n",++ip, sf,cols,rows);

  uninw=UNINW;
l00:         // loop pointer: if backgroud too high, (reduce>20) do again
  reduce=0;  w99=uninw+40;  oldrows=rows; // in expblock, 1st_data threshold
// white_black reverse, define background ~ 0
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[j][i]=255-obits[j][i];
  if(h[14]!=8){ printf("\tsorry, not a 256_color BMP file\n"); goto l99; }

// sharpness pic, by using uninw, smooth backgroud,        sharpness WHITE
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(bits[j][i]<uninw)bits[j][i]=0;
                                              // must donot sharpness BLACK
//de_noise
  alone();                                    // de_alone pointer

// resize pic
  j=rows/2;                                   //get bar X_length
  k=0; for(i=0;i<cols;i++){ if(bits[j][i])k++; else k=0; if(k>3)break;} i1=i-3;
  k=0; for(i=cols-1;i>0;i--){if(bits[j][i])k++;else k=0; if(k>3)break;} i2=i+3;
  k=i2-i1;
  if(k>expixel)goto l10;
  i1-=30; if(i1<0)i1=0; i2+=30;
  expand2(i1,i2);  oldrows=rows;              // rows, cols changed; *2-1
//test1();

l10:                                          // loop pointer, for reverse pic.
// find 4 corner, roughly
  for(j=0;j<rows;j++)work[j]=0;               // project in X
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)work[j]+=bits[j][i];
  for(j=0;j<rows;j++)work[j]/=cols;
  for(j=rows/2;j>=0;j--)  if(work[j]*2<work[j+1])break; v1=j; if(v1<0)v1=0;
  for(j=rows/2;j<rows;j++)if(work[j]*2<work[j-1])break; v2=j; if(v2==rows)v2--;
//for(j=0;j<rows;j++)printf("%d ",work[j]); printf("\n");
  for(i=0;i<cols;i++)work[i]=0;                         // project in Y
  for(i=0;i<cols;i++)for(j=0;j<rows;j++)work[i]+=bits[j][i];
  for(i=0;i<cols;i++)work[i]/=rows;
  for(i=0;i<cols;i++)  if(work[i])break; u1=i--; if(u1<0)u1=0;
  for(i=cols-1;i>0;i--)if(work[i])break; u2=i++; if(u2==cols)u2--;
  for(i=u1;i<cols/2;i++){  k=0;                        // calculte u1,u2 more
    for(j=v1;j<v2;j++)if(bits[j][i]>uninw)k++; if(k>9)break; } u1=i;
  for(i=u2;i>cols/2;i--){  k=0;
    for(j=v1;j<v2;j++)if(bits[j][i]>uninw)k++; if(k>9)break; } u2=i;
//for(i=0;i<cols;i++)printf("%d ",work[i]); printf("\n");
//printf("u1,u2  v1,v2: %d %d    %d %d\n",u1,u2,v1,v2);
// locate 4 corner in detail
  corner(u1,v1,&x1,&y1, 1, 1);   //0,0  ------>
  corner(u1,v2,&x2,&y2, 1,-1);   // |   x1,y1         x3,y3
  corner(u2,v1,&x3,&y3,-1, 1);   // |
  corner(u2,v2,&x4,&y4,-1,-1);   // v   x2,y2         x4,y4
//printf("1,2,3,4:  %d_%d  %d_%d  %d_%d  %d_%d\n",x1,y1,x2,y2,x3,y3,x4,y4);
//test2();

// if reverse pic
  k=(x1+x2)/2;  u=0;   w=(y2-y1)/2;
  for(j=y1;j<y2;j++)for(i=k;i<k+w;i++)u+=bits[j][i];
  k=(x3+x4)/2;  v=0;
  for(j=y3;j<y4;j++)for(i=k-w;i<k;i++)v+=bits[j][i];
//printf("%d %d\n",u,v);
  if(u<v){
  if(P)printf("*** turn pic 180 degree\n");
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=bits[j][i];
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[rows-j-1][cols-i-1]=btmp[j][i];
    goto l10;
  }

// set coordination, two line's TAN is not the same
  f1=(float)(y3-y1); f1/=(x3-x1);
  f2=(float)(y4-y2); f2/=(x4-x2);
//printf("f1 f2: %f %f\n",f1,f2);
// create function:  f(y)=f1+fc*(y-y1)
  fc=(f2-f1)/(y2-y1);
  if(P)printf("slip:  %f   code_high: %d",(f1+f2)/2,(y2-y1+y4-y3)/2+1);

// workout row_direction, how may lines of code_data, ie. jbar
  for(i=0;i<rows;i++)w2[i]=0;
  for(i=0;i<cols;i++)work[i]=-1;
// 1st work out a line, then can .. work[i]-work1[i], from y1-2
  u=y1-2; if(u<0)u=0;                           // range of ybar[]
  v=y2+2; if(v>rows-1)v=rows-1;
  for(i=0;i<cols;i++){
    j=(i-x1)*(f1+fc*(u-y1))+u;    if(j>=0 && j<rows)work[i]=bits[j][i]; }
  for(k=u+1;k<=v;k++){
    for(i=0;i<cols;i++)work1[i]=-1;
    for(i=0;i<cols;i++){
      j=(i-x1)*(f1+fc*(k-y1))+k;  if(j>=0 && j<rows)work1[i]=bits[j][i]; }
    for(i=j1=0;i<cols;i++){
      j2=0; if(work[i]!=-1 && work1[i]!=-1)j2=work1[i]-work[i];
      if(j2<0)j2=-j2;        j1+=j2;
    }
    w2[k]=j1;                                   // w2: delta 2 lines differ
    for(i=0;i<cols;i++)work[i]=work1[i];        // for next line process
  }
//for(i=0;i<rows;i++){printf("%6d",w2[i]);if(i%13==12)printf("\n");}printf("\n") ;
  for(i=0;i<rows;i++)  if(w2[i])break; i1=i;
  for(i=rows-1;i>0;i--)if(w2[i])break; i2=i;
  for(i=i1+1;i<i2;i++) if(w2[i]==0)w2[i]=1;     // avoid in range, value=0
  smooth(w2,work1,rows);
//for(i=0;i<rows;i++){printf("%6d",w2[i]);if(i%13==12)printf("\n");}printf("\n") ;
  for(i=u,jbar=j=0;i<=v;i++){
    if(w2[i-1]==0) continue;                    // skip, if first part =0
    if(w2[i+1]==0) break;
    if(w2[i]<w2[i-1] && w2[i]<=w2[i+1]){        // find min "change value"
      if(w2[i]==w2[i+1])i++;   if(w2[i]<1000)i++;
      work1[jbar]=w2[i];
      ybar[jbar++]=i-1;
      i++;  while(w2[i]<1000)i++;
    }                                       // for gap large_type, ex: i01.bmp
  }                                         // jbar gotten
  if(jbar<3){ printf("\tsorry, cannot work out\n"); goto l99; }
  adjustjbar(ybar,work1);                   // jbar maybe changed
  f2=ybar[jbar-1]-ybar[0]; f2/=jbar;   bargap=f2+0.5;
  if(P)printf(" jbar: %d bargap: %5.2f\n",jbar,f2);
  goto lw2;                                 // tested, goto lw2, is better
// another method, fixed y[0],y[j-1], get average jbar[];
  work[0]=ybar[0]; work[jbar-1]=ybar[jbar-1];
  f2=work[jbar-1]-work[0]; f2/=(jbar-1);
  for(i=1;i<jbar-1;i++)work[i]=work[0]+f2*i+0.5;
//for(i=0;i<jbar;i++)printf("%d %d\n",ybar[i],work[i]); printf("\n");
  for(i=0;i<jbar;i++)ybar[i]=work[i];

lw2:
//each start x_position of bar[jbar][]
  f2=x1-x2; f2/=(y1-y2);
  for(i=0;i<jbar;i++) xbar[i]=x1-(y1-ybar[i])*f2;

//take data  bits[rows][] --> bar[jbar][]
  for(k=0;k<jbar;k++){
    for(i=0;i<cols;i++){
      bar[k][i]=0;
      j=(i-x1)*(f1+fc*(ybar[k]-y1))+ybar[k];
      if(j>=0&&j<rows)bar[k][i]=bits[j][i];
    }                      // according ybar[],  extract line ---> bar[k][i];
  }                        // may get average ybar[], according: jbar
// total bar_num: jbar, data array: bar[jbar][cols], start at xbar[jbar]
// ybar[jbar]= real line_number of bits, for plot only. save for a while
// get scale, ie. block 1/17 pixel number, next get how may blocks
// each bar, has diff start_col in xbar[];
  total=(x3-x1+x4-x2)/2+1;
  i=xbar[jbar/4]; for(j=i+9;j<cols;j++)if(bar[jbar/4][j]<uninw)break; i1=j-i;
  i=xbar[jbar/2]; for(j=i+9;j<cols;j++)if(bar[jbar/2][j]<uninw)break; i2=j-i;
  k=jbar/4*3; i=xbar[k]; for(j=i+9;j<cols;j++)if(bar[k][j]<uninw)break; w=j-i;
  if(w<i1)w=i1; if(w<i2)w=i2;
  f2=w/8.;                           // use first block's 8 unit, roughtly f2
  f2*=17; nblock=total/f2+0.5;                       // get nblock
  f2=total; f2/=(nblock*17+1);                       // detail scale: f2
  w=f2*17.+0.5;                                      // 1 block data_length
  ibar=nblock*17+1;
  if(P)printf("bar_len: %d  blocks: %d  real_scale:%7.4f\n",total,nblock,f2);
  k=f2+0.5; if(k<2){ printf("\tSorry, I cannot workout\n"); goto l99; }

//if backgroud too high
  if(nblock<5){ uninw=uninw+dunin;
  if(P)printf("change uninw: %d\n",uninw);
  goto l00; }

//  bar[jbar][cols]  get from bits
// sbar[jbar][cols], after processblock,
// tbar[jbar][17*nblock+1]  after process17
// adjust bar[jbar][] Y_direction slip
  i1=xbar[jbar/2];
  for(v=0;v<jbar;v++){
    k=xbar[v]-i1;
    for(i=0;i<cols;i++)work[i]=bar[v][i];       //  bar adjust Y_direction
    for(i=0;i<cols;i++)bar[v][i]=work[i+k];
    for(i=0;i<i1-2;i++)bar[v][i]=0;             // clear 2_ends
    for(i=cols-1;i>i1+total+2;i--)bar[v][i]=0;  // end,  need not clear.
  }

// re_project, calculate f2, using bar[jbar][]
  for(i=0;i<cols;i++){
    for(j=k=0;j<jbar;j++)if(bar[j][i])k++; work[i]=k>(jbar/2)?1:0;
  }
  for(i1=0;i1<cols;i1++)  if(work[i1])break;  start=i1;
  for(i2=cols-1;i2>0;i2--)if(work[i2])break;
  total=i2-i1+1;  f2=total; f2/=ibar;         w=f2*17.+0.5;
  if(P)printf("new_par: start: %d total %d   scale: %6.4f\n",start,total,f2);

// adjust shape of sbar and change to 0 or 255
  for(v=0;v<jbar;v++){
    for(j=0;j<=cols;j++)work[j]=bar[v][j];
    for(i=1;i<nblock-1;i++){                       // ignore start,end block
      j=start+i*w-(f2+1.)/2.; if(j<0)j=0;
      for(k=j;k<j+3;k++)if(work[k]==0)break; if(k!=j+3)j=k;
      for(k=j;k<j+9;k++){ if(work[k]>w99)break; else work[k]=0; }  //clear edge
      if(i!=nblock)expblock(&work[k],w,f2,work1,v,i);
    }
    for(j=0;j<cols;j++)sbar[v][j]=work[j]?255:0;
  }

// project Y for sbar, to work[], out xbar[]
  for(i=0;i<cols;i++){
    for(j=k=0; j<jbar; j++)if(sbar[j][i])k++;
    work[i]=(k>jbar/2)?1:0;
  }

// get new xbar[], for block start_position
  for(i=0;i<=nblock;i++){
    k=i*17*f2+start;
    if(work[k]==0){ for(j=k;j<k+20;j++)if(work[j])break; }
    else { for(j=k;j>=0; j--)if(work[j]==0)break; j++; }
    xbar[i]=j;
  }

// adjust sbar &  shrink  sbar ---> tbar
  for(j=0;j<jbar;j++){
    for(i=0;i<17;i++)tbar[j][i]=h1[i];                    // put line_head
    for(v=1,i=17;v<nblock-1;v++){
//  aother method, get data of tbar:
//    f3=xbar[v+1]-xbar[v]; f3/=17.;
//    for(u=0;u<17;u++){
//      k=u*f3+xbar[v]+f3*.5+0.5;
//      tbar[j][i++]=sbar[j][k];
//      sbar[j][k]=sbar[j][k]?1:2;                        // print mark
//    }
      u=xbar[v];
  //  if(sbar[j][u]==0)u++;                               // adjust 1 point
      for(k=u,w=0;k<xbar[v+1];k++)work[w++]=sbar[j][k];
  //  if(sbar[j][k]==0)w++;                               // adjust 1 point
      exp17(work,w,j,v);                                  // 17 judge
      for(u=0;u<17;u++)tbar[j][i++]=work[u];
    }
    for(k=0;k<18;k++)tbar[j][i++]=h2[k];                  // put line_end
  }
  if(P)printf("reduce: %d\n",reduce);
  if(reduce>20){ uninw+=dunin;
  if(P)printf("AGAIN, uninw: %d\n",uninw);
  goto l00; }

// save data of tbar(BMP)
  sprintf(sb,"s%s",sf);
  fp=fopen(sb,"wb");
  for(i=0;i<256;i++){ th[2*i+27]=(i<<8)|i; th[2*i+28]=i; }
  u=tbar[0][19]&tbar[0][18];
  if(P)if(u==0)printf("***** pic turn 180 degree around X_axis\n");
  th[9]=ibar*2; th[11]=jbar*2;                     // 2*2 for a pointer
  fwrite(th,2,539,fp); k=(ibar*2+3)/4*4;           // for check easy
  for(j=0;j<jbar;j++){                             // u==0; mirror correct
    if(u==0) for(i=0;i<ibar;i++)btmp[0][i*2]=btmp[0][i*2+1]=255-tbar[j][i];
    else for(i=0;i<ibar;i++)btmp[0][i*2]=btmp[0][i*2+1]=255-tbar[jbar-j-1][i];
    fwrite(btmp[0],1,k,fp);
    fwrite(btmp[0],1,k,fp);
  }
/*
  th[9]=ibar; th[11]=jbar*2;                       // 1*2 for a pointer
  fwrite(th,2,539,fp); k=(ibar+3)/4*4;             // just for pdf17
  for(j=0;j<jbar;j++){
    if(u==0) for(i=0;i<ibar;i++)tbar[jbar][i]=255-tbar[j][i];
    else for(i=0;i<ibar;i++)tbar[jbar][i]=255-tbar[jbar-j-1][i];
    fwrite(tbar[jbar],1,k,fp);
    fwrite(tbar[jbar],1,k,fp);
  }
//----
  w=9;  th[9]=ibar*w+60; th[11]=jbar*w+40;         // 9*9, w canbe any
  fwrite(th,2,539,fp); k=(th[9]+3)/4*4;
  for(i=0;i<n1;i++)btmp[0][i]=255;  for(j=0;j<20;j++)fwrite(btmp[0],1,k,fp);
  for(j=0;j<jbar;j++){
    if(u==0)for(i=0;i<ibar;i++)for(v=0;v<w;v++)btmp[0][i*w+v+30]=255-tbar[j][i];
else for(i=0;i<ibar;i++)for(v=0;v<w;v++)btmp[0][i*w+v+30]=255-tbar[jbar-j-1][i];
    for(v=0;v<w;v++)fwrite(btmp[0],1,k,fp);
  }
  for(i=0;i<n1;i++)btmp[0][i]=255;  for(j=0;j<20;j++)fwrite(btmp[0],1,k,fp);
*/
  fclose(fp);
  printf("re_shape file produced: %s\n",sb);       // next:  pdf417 process
//goto l99;
//}


//
//***********************************
  if(ac>2)goto l99;
//#define green 1
//#define red   2
// output 3_map of BMP format
  out3bmp("bb.bmp",start);

// mark on bits_pic,  track, start position, position mark
// plot curve                     use bar[jbar][] data
  for(k=0;k<jbar;k++){
    for(i=0;i<cols;i++){
      j=(i-x1)*(f1+fc*(ybar[k]-y1))+ybar[k];
      if(j>=0 && j<rows)bits[j][i]=2; //red
    }
  }
  cross(u1,v1,2);  cross(u1,v2,2);  cross(u2,v1,2);  cross(u2,v2,2);
  cross(x1,y1,1);  cross(x2,y2,1);  cross(x3,y3,1);  cross(x4,y4,1);
  for(i=j=0;i<jbar;i++){
    pcurve(bar,i,2,j);    j=1-j;        // red
    pcurve(sbar,i,1,j);   j=1-j;        // green
  }
  pw2(1);                               // green
  outbmp("b.bmp");

//if link job
//sprintf(sb,"a s%s 99",sf); system(sb);      // a: pdf417 standard route
  sprintf(sb,"aa s%s",sf); system(sb);        // a: pdf417 standard route
  goto l99;
}

pw2(int color)
{
  int i,j; float fx;
  fx=(x2-x1); fx/=(y2-y1);
  for(j=0;j<oldrows;j++){
    i=x1+(j-y1)*fx+0.5;
    i+=w2[j]>>10;
    bits[j][i]=color;
  }
}

pcurve(a,k,color,z)
unsigned char a[][n1]; int k,color,z;
{
  int i,j;
  for(i=0;i<cols;i++){ j=(i-x1)*(f1+fc*(ybar[k]-y1))+ybar[k];
    if(j>=0 && j<rows)bits[j][i]=2; }
  for(i=0;i<cols;i++){ j=8-(a[k][i]>>5); bits[j+rows][i]=color;  }
  if(z){ rows+=12; h[11]=rows; }
}

cross(int x, int y, int color)               // plot cross mark.
{
  int i,j;
  for(j=y-5;j<=y+5;j++)if(j>=0 && j<n2)bits[j][x]=color;
  for(i=x-5;i<=x+5;i++)if(i>=0 && i<n1)bits[y][i]=color;
}

outbmp(char *f)                     // output bits_file with mark & curve
{
  FILE *fp;
  int i,j,k=(cols+3)/4*4;
// define color;
  h[535]=0xff00; h[536]=0;                     // coror 1: green
  h[533]=0;                                    // color 2: red
  fp=fopen(f,"wb");  fwrite(h,2,539,fp);
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=255-bits[j][i];
  for(j=0;j<rows;j++)fwrite(btmp[rows-j-1],1,k,fp);  fclose(fp);
}

out3bmp(char *f)                    // 1. bar, after wave_adjust
{                                   // 2. raw map
  FILE *fp;                         // 3. out_bar, sb.bmp,
  int i,j,k=(cols+3)/4*4,u,v,w;
  w=f2+0.5;
  h[11]=rows+jbar*(bargap+w);
  fp=fopen(f,"wb");  fwrite(h,2,539,fp);
// tbar
  for(i=0;i<jbar;i++){
    for(j=0;j<cols;j++)btmp[i][j]=255;
    for(j=0;j<ibar;j++){ u=255-tbar[jbar-i-1][j];
      for(v=0;v<w;v++)btmp[i][start+j*w+v]=u;    }
    for(j=0;j<w;j++)fwrite(btmp[i],1,k,fp);
  }
// obits, due to BMP_color_plate changed, red=253, green=254, not appear
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(obits[j][i]>=253)obits[j][i]=255;
  for(j=0;j<rows;j++)fwrite(obits[rows-j-1],1,k,fp);
// sbar
  for(i=0;i<jbar;i++){
    for(v=0;v<bargap;v++){
      for(j=0;j<cols;j++)btmp[i][j]=255-sbar[jbar-i-1][j];
//      if(v!=bargap/2) for(u=0;u<cols;u++){          // use for locate point.
//        if(btmp[i][u]==253)btmp[i][u]=255;          // another method
//        if(btmp[i][u]==254)btmp[i][u]=0; }          // by calclute
      fwrite(btmp[i],1,k,fp);
    }
  }
  fclose(fp);
}

test1(){  printf("out raw b.bmp only!\n"); outbmp("b.bmp");   exit(0);}

test2()
{
  printf("out cross b.bmp only!\n");
  cross(u1,v1,2);  cross(u1,v2,2);  cross(u2,v1,2);  cross(u2,v2,2);
  cross(x1,y1,1);  cross(x2,y2,1);  cross(x3,y3,1);  cross(x4,y4,1);
  outbmp("b.bmp");
  exit(0);
}
