// assume cols > rows, if not, turn pic 90 degree please.
// not allowed comment_chars_print_length, longer than cord-bar.
//  otherwise: cord-bar parrallel X-axis, has a white_line separating
// input *.bmp, color_plate in 00~255 grade.
#include <stdio.h>
#include <string.h>
#define n1 2048
#define n2  512
#define uninw   80             // for sharpness
#define white    0             // define 5 colors
#define green    1             // for test plot
#define red      2
#define pink     3
#define black  255
unsigned char bits[n2][n1],btmp[n2][n1];
unsigned short h[539];                           // 27+512
int work[2048],work1[2048];
int work2[512];                // max row of code
int rows,cols;
int u1,u2,v1,v2;
int x1,x2,x3,x4,y1,y2,y3,y4;
int hist[256];
FILE *fp;
corner(u,v,x,y,zx,zy)
int u,v,zx,zy, *x,*y;
{
  int i,j,q,r,s,t;
  for(r=0;r<rows/2;r++)
  for(j=0;j<=r;j++)for(i=0;i<=r;i++)if(i+j==r){
    s=u+i*zx; t=v+j*zy;
    if(s<0)s=0; if(s>cols-1)s=cols-1;
    if(t<0)t=0; if(t>rows-1)t=rows-1;
    if(bits[t][s]>uninw)
    if(bits[t+zy][s+zx]>uninw)
    if(bits[t+zy*2][s+zx*2]>uninw)goto l10;
  }
l10:
  s+=zx*2; t+=zy*2;
  for(j=0;j<5;j++){ r=t-j*zy;
    if(r<0 || r>rows-1)break; if(bits[r][s]<uninw)break; }
  for(i=0;i<5;i++){ q=s-i*zx;
    if(q<0 || q>cols-1)break; if(bits[t][q]<uninw)break; }
  *x=q+zx;  *y=r+zy;
//printf("%d %d\n",*x,*y);
}

cross(x,y,color)
int x,y,color;
{
  int i,j;
  for(j=y-5;j<=y+5;j++)if(j>=0 && j<n2)bits[j][x]=color;
  for(i=x-5;i<=x+5;i++)if(i>=0 && i<n1)bits[y][i]=color;
}

outbmp(f1)
char *f1;
{
  FILE *fp;
  int i,j,k=(cols+3)/4*4;
  fp=fopen(f1,"wb");  fwrite(h,2,539,fp);
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=255-bits[j][i];
  for(j=0;j<rows;j++)fwrite(btmp[rows-j-1],1,k,fp);  fclose(fp);
}

filter(kk)
int kk;
{
  int i,j,k,i1,j1,i2,j2,f;
  unsigned char a[81],c;           // max f=4; 9*9 filter
  f=kk; if(f>4)f=4;
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=bits[j][i];
  for(j=f;j<rows-f;j++)for(i=f;i<rows;i++){    k=0;
    for(j1=j-f;j1<=j+f;j1++)for(i1=i-f;i1<=i+f;i1++)a[k++]=btmp[j1][i1];
    for(i2=0;i2<k-1;i2++)for(j2=i2+1;j2<k;j2++)if(a[i2]>a[j2]){
      c=a[i2]; a[i2]=a[j2]; a[j2]=c;
    }
    bits[j][i]=a[k/2];
  }
}

smooth(w,v,n)
int *w,*v,n;
{
  int i,k=1;              // 1st not take part in smooth, due to too large
  for(i=0;i<n;i++)v[i]=w[i];
  for(i=1;i<n-1;i++){
    if(v[i-1]==0)continue;
    if(k){ k=0;  continue; }
    if(v[i+1]==0)break;
    w[i]=(v[i-1]+v[i+1]+v[i]*2)/4;
  }
}

adjustw2(w,v,n)
int *w,*v,n;
{
  int i,j=0,k,z[32],l,oldi=-2;
  float x;

  x=(float)(w[n-1]-w[0]); x/=(float)(n-1);
  printf("  bar_gap_pixel: %5.2f\n",x);
  k=(int)(x+0.5); w[0]=w[1]-k;  w[n-1]=w[n-2]+k;
  for(i=0;i<n;i++)v[i]=w[i+1]-w[i];
//for(i=0;i<n;i++)printf("%d_%d ",w[i],v[i]); printf("--%d\n",n);
  for(i=0;i<n-2;i++){
    k=w[i+1]-w[i]; k-=(int)x;
    if(k>1){ z[j]=i; if(i!=oldi+1)j++; oldi=i; }
  }
//for(i=0;i<j;i++)printf("%d",z[i]); printf("\n");
  if(j){
    for(i=l=0;i<j;i++){
      k=v[z[i]]-v[z[i]+1]; if(k<0)k=-k;
      if(k>1){
        l++; if(v[z[i]]>v[z[i]+1])w[z[i]+1]--; else w[z[i]+1]++;
        continue;
      }
      k=v[z[i]]-v[z[i]-1]; if(k<0)k=-k;
      if(k>1){
        l++; if(v[z[i]]>v[z[i]-1])w[z[i]]++; else w[z[i]]--;
      }
    }
//if(l)for(i=0;i<n;i++)printf("%d_%d ",w[i],w[i+1]-w[i]); printf("\n");
  }
}

float f1,f2;
unsigned char bar[32][2048];          // last result
unsigned char sbar[32][2048];         // wave(shape) adjust
int   unit,  jbar, xbar[32];          // total bar number
int                  nblock;          // ~6
main(int ac, char **av)
{
  int i,j,k,u,v,w;
  int i1,i2,j1,j2;
  if(ac<2){ printf("\n\t c ?.bmp\n\n"); return 0; }
  fp=fopen(av[1],"rb");  if(fp==0){printf("\n\tfile not found!\n"); return 0;}
  fread(h,2,539,fp);
  cols=h[9]; rows=h[11];  k=(cols+3)/4*4;
// define color; 1 green; 2 red;  3 pink;
  h[531]=0xff;                 // color 3: pink
  h[533]=0;                    // color 2: red
  h[535]=0xff00; h[536]=0;     // coror 1: green
  if(cols>n1)cols=n1; if(rows>n2)rows=n2;      // take 2048*512 max pic
  for(j=0;j<rows;j++)fread(&bits[rows-j-1][0],1,k,fp);  fclose(fp);
printf("%s %d*%d\n",av[1],cols,rows);
// white_black reverse
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[j][i]=255-bits[j][i];
// sharpness pic, by using uninw, smooth backgroud,
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)if(bits[j][i]<uninw)bits[j][i]=0;
//delete noise,  3*3 filter    3*3, dummy=1; 5*5, dummy=2; ...
  filter(1);
// find 4 corner
l10:
  for(j=0;j<rows;j++)work[j]=0;
  for(j=0;j<rows;j++)for(i=0;i<cols;i++)work[j]+=bits[j][i];
  for(j=0;j<rows;j++)work[j]/=cols;
  for(j=rows/2;j>=0;j--)  if(work[j]*2<work[j+1])break; v1=j; if(v1<0)v1=0;
  for(j=rows/2;j<rows;j++)if(work[j]*2<work[j-1])break; v2=j; if(v2==rows)v2--;
//for(j=0;j<rows;j++)printf("%d ",work[j]); printf("\n");
  for(i=0;i<cols;i++)work[i]=0;
  for(i=0;i<cols;i++)for(j=0;j<rows;j++)work[i]+=bits[j][i];
  for(i=0;i<cols;i++)work[i]/=rows;
  for(i=0;i<cols;i++)  if(work[i])break; u1=i--; if(u1<0)u1=0;
  for(i=cols-1;i>0;i--)if(work[i])break; u2=i++; if(u2==cols)u2--;
  for(i=u1;i<cols/2;i++){  k=0;
    for(j=v1;j<v2;j++)if(bits[j][i]>uninw)k++; if(k>9)break; } u1=i;
  for(i=u2;i>cols/2;i--){  k=0;
    for(j=v1;j<v2;j++)if(bits[j][i]>uninw)k++; if(k>9)break; } u2=i;
//for(i=0;i<cols;i++)printf("%d ",work[i]); printf("\n");
//printf("u1,u2  v1,v2: %d %d    %d %d\n",u1,u2,v1,v2);
  corner(u1,v1,&x1,&y1, 1, 1);   //0,0  ------>
  corner(u1,v2,&x2,&y2, 1,-1);   // |   x1,y1         x3,y3
  corner(u2,v1,&x3,&y3,-1, 1);   // |
  corner(u2,v2,&x4,&y4,-1,-1);   // v   x2,y2         x4,y4
//printf("%d %d %d %d    %d %d %d %d\n",x1,x2,x3,x4,y1,y2,y3,y4);
// if reverse
  k=(x1+x2)/2;  u=0;   w=(y2-y1)/2;
  for(j=y1;j<y2;j++)for(i=k;i<k+w;i++)u+=bits[j][i];
  k=(x3+x4)/2;  v=0;
  for(j=y3;j<y4;j++)for(i=k-w;i<k;i++)v+=bits[j][i];
//printf("%d %d\n",u,v);
  if(u<v){ printf("*** turn pic 180 degree\n");
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)btmp[j][i]=bits[j][i];
    for(j=0;j<rows;j++)for(i=0;i<cols;i++)bits[rows-j-1][cols-i-1]=btmp[j][i];
    goto l10;
  }
// set coordination, two TAN is not the same
//y=(x-x1)*(y3-y1)/(x3-x1)+y1;
  f1=(float)(y3-y1); f1/=(x3-x1);
  f2=(float)(y4-y2); f2/=(x4-x2);
  f1=(f1+f2)/2.;
printf("slip:  %f   code_high: %d",f1,(y2-y1+y4-y3)/2);
// workout drow, how may lines of code_data
  for(i=0;i<rows;i++)work2[i]=0;
  for(i=0;i<cols;i++)work[i]=-1;
  for(i=0;i<cols;i++){  j=(i-x1)*f1+y1; if(j>=0&&j<rows)work[i]=bits[j][i]; }
  for(k=y1+1;k<=y2+2;k++){
    for(i=0;i<cols;i++)work1[i]=-1;
    for(i=0;i<cols;i++){j=(i-x1)*f1+k; if(j>=0&&j<rows)work1[i]=bits[j][i]; }
    for(i=j1=0;i<cols;i++){
      j2=0; if(work[i]!=-1 && work1[i]!=-1)j2=work[i]-work1[i];
      if(j2<0)j2=-j2;  if(j2<30)j2=0; j1+=j2;
    }
    for(i=0;i<cols;i++)work[i]=work1[i];
    work2[k]=j1;
  }
//for(i=0;i<rows;i++){ printf("%6d",work2[i]); if(i%13==12)printf("\n"); }
//printf("\n");
  for(i=0;i<rows;i++)  if(work2[i])break; i1=i;
  for(i=rows-1;i>0;i--)if(work2[i])break; i2=i;
  for(i=i1+1;i<i2;i++) if(work2[i]==0)work2[i]=1;
  smooth(work2,work1,rows);
  smooth(work2,work1,rows);
//for(i=0;i<rows;i++){ printf("%6d",work2[i]); if(i%13==12)printf("\n"); }
//printf("\n");
  for(i=1,k=0;i<rows;i++){
    if(work2[i-1]==0) continue;
    if(work2[i+1]==0) break;
    if(work2[i]<work2[i-1] && work2[i]<work2[i+1]){
      work2[k++]=i-1;
      i++;  while(work2[i]<1000)i++;      // for gap large_type, ex: i01.bmp
    }
  }
  adjustw2(work2,work1,k);
  jbar=k;
//each star x_position of bar[jbar][]
  f2=x1-x2; f2/=(y1-y2);
  for(i=0;i<jbar;i++) xbar[i]=x1-(y1-work2[i])*f2;
// save dat of bar
  fp=fopen("b.bin","wb");
  fwrite(&k,1,4,fp); fwrite(&cols,1,4,fp);
  for(k=0;k<jbar;k++){
    for(i=0;i<cols;i++){
      bar[k][i]=0;
      j=(i-x1)*f1+work2[k]; if(j>=0 && j<rows)bar[k][i]=bits[j][i];
    }
    fwrite(bar[k],1,cols,fp);
  } fclose(fp);
// total bar_number: jbar
// total data array: bar[jbar][cols], start at xbar[jbar]
// work2[jbar]= real line_number of bits, for plot only. save for a while
//-----------
// get unit, ie. block 1/17 pixel number, next get how may blocks
// each bar, has diff start_col in xbar[32];
  k=(x3-x1+x4-x2)/2;  i=xbar[jbar/2];
  for(j=i+2;j<cols;j++)if(bar[jbar/2][j]<40)break;
  j=(j-i)>>3;                                        // first black, 8 unit
  f2=j*17; i=k/f2+0.5; f2=k; f2/=(i*17+1);           // scale: f2
  unit=j;                                            // unit:  3-6 pixel
  w=f2*17.+0.5;                                      // 1 block data length
  nblock=i;                                           // ~6
  printf("bar_len: %d  unit: %d  blocks: %d  real_scale: %6.4f\n",k,j,i,f2);
// work out n blocks start posi:
  for(j=0;j<cols;j++)work[i]=0;                      // clear 2_ends
  for(j=xbar[0];j<=xbar[0]+k;j++)work[j]=bar[0][j];
  for(i=0;i<=nblock;i++){
    if(i==0)k=xbar[0]; else {
      j=xbar[0]+i*w-3; for(k=j;k<j+9;k++)if(work[k]>100)break; else work[i]=0;
//printf("%d_%d ",j,k);
    }
    if(i!=nblock)processblock(&work[k],w,unit);
  }
  for(j=0;j<cols;j++)sbar[0][j]=work[j]?255:0;

//----- output MAP
// scan track, start position
for(k=0;k<jbar;k++){
  for(i=0;i<cols;i++){
    j=(i-x1)*f1+work2[k]; if(j>=0 && j<rows)bits[j][i]=3;
  }
  bits[work2[k]][xbar[k]]=1;
}
// 1st corner location
cross(u1,v1,red);  cross(u1,v2,red);  cross(u2,v1,red);  cross(u2,v2,red);
// 2nd corner location
cross(x1,y1,green);cross(x2,y2,green);cross(x3,y3,green);cross(x4,y4,green);
// plot curve            use bar[0-16][] data
  pcurve(bar,0,red);         // curve number(0~jbar), color
  pcurve(sbar,0,green);         // curve number(0~jbar), color
  outbmp("b.bmp");
  system("d b.bin");
  return 0;
}

processblock(int *a, int w, int unit)
{
  int i,j,j1,j2,k;
//for(i=0;i<w;i++)printf("%d ",a[i]); printf("\n");
// check 00 apear 4 times;
  j=0; for(i=0;i<w;i++)if(a[i]==0){ if(k==1){ j++; k=0;}} else k=1;
//if(j!=4){ printf("I need a route *****n"); return 0; }
//expand 00 --> 0000 (number of unit)
  i=0;
l20:
  i++; if(i>=w)return;
  if(a[i])goto l20;             // find 0
  j=i; while(a[i]==0)i++;       // find 1
  k=i-j; k%=unit; if(k==0)goto l20;
  j1=j-1; j2=i;  k=unit-k;
l30:
  if(k==1){ if(a[j1]>a[j2])a[j2]=0; else a[j1]=0; goto l20; }
  if(k>=2){ a[j1--]=a[j2++]=0; if(k==2)goto l20; }
  k-=2; goto l30;
}

pcurve(a,k,color)
unsigned char a[32][2048]; int k,color;
{
  int i,j;
  for(i=0;i<cols;i++){ j=(i-x1)*f1+work2[k]; if(j>=0 && j<rows)bits[j][i]=3; }
  for(i=0;i<cols;i++){ j=16-(a[k][i]>>4); bits[j+rows][i]=color;  }
  rows+=20; h[11]=rows;
}
