#include <stdio.h>
FILE *fp,*fp1;
char color[9],f1[60],a[220],c34=34;;
float x,y,z;
int   ixy,size;

main(int ac,char **av)
{
  int i,j,k,ip,it;
  char c1[14],c2[14];
  if(ac<3){ printf("\n\t ****** produce *.reg file for DS9 *****\n");
         printf("\n\tUsage: ds9_reg input.cat column [color] [size] [x_y]\n");
         printf("\n\tEx:    ds9_reg a0117.cat 32");
         printf("\n\t          ==> outfile is:  a0117_green_20.reg");
         printf("\n\tEx:    ds9_reg a0117.cat 6 red 10");
         printf("\n\t          ==> outfile is:  a0117_red_18.reg");
         printf("\n\tnote:");
         printf("\n\t   column: start columns of X,Y or FK5 Coordination");
         printf("\n\t   color:  default is green");
         printf("\n\t   size:   circle radius, default 20 pixels or 10 arcsec");
         printf("\n\t   x_y:    if X,Y's or Ra,DEC's position reversed\n\n");
    exit(0);            
  }
  fp=fopen(av[1],"r"); if(fp==0){ printf("%s not found!\n",av[1]); exit(0); }
  sscanf(av[2],"%d",&j);
  strcpy(color,"green"); size=ixy=0;
  if(ac>3){
    strcpy(color,av[3]);
    if(ac>4){
      sscanf(av[4],"%d",&size);
      if(ac>5)ixy=1;         // if(ixy)changeXY;
    }
  } 
// workout outfile name
  strcpy(f1,av[1]); k=strlen(f1);
  for(i=k;i>0;i--)if(f1[i]=='.'){ f1[i]=0; break; }
  fp1=fopen("ds9_reg.tmp","w");
  fprintf(fp1,"# YOU entered command is: ds9_reg ");
  for(i=1;i<ac;i++)fprintf(fp1,"%s ",av[i]); fprintf(fp1,"\n");  
  fprintf(fp1,"global color=%s font=%chelvetica 10 normal%c ",color,c34,c34);
  fprintf(fp1,"select=1 highlite=1 edit=1 move=1 delete=1 include=1 fixed=0 source\n");
  ip=0;
l10:
  fgets(a,220,fp); if(feof(fp))goto l20;
  if(a[0]=='#')goto l10;
  k=strlen(a); 
  for(i=j;i<k-1;i++)if(a[i]==',')a[i]=32;  
  sscanf(&a[j],"%s %s",c1,c2);
  if(ip==0){
    it=20; for(i=0;i<strlen(c1);i++)if(c1[i]==':')it=10;
    if(it==10)fprintf(fp1,"FK5\n"); else fprintf(fp1,"image\n");
    if(size==0)size=it;
  }
  if(ixy==0)fprintf(fp1,"circle(%s,%s,%d",c1,c2,size);
  if(ixy==1)fprintf(fp1,"circle(%s,%s,%d",c2,c1,size);
  if(it==10)fprintf(fp1,"%c",c34);
  fprintf(fp1,")\n");
  ip++;
  goto l10;
l20:
  fclose(fp1); fclose(fp);
  sprintf(f1,"%s_%s_%d.reg",f1,color,size);
  sprintf(a,"mv ds9_reg.tmp %s",f1); system(a);
  if(it==10)printf("==> format in FK5;  ");
   else     printf("==> format in X,Y;  ");
  printf("outputfile: %s   ok!\n",f1);
}
