#include <stdio.h>
#include <math.h>
#define nb  65536
FILE *fp[99],*fp1;
char h[72][80];
float a[16000*16000];
float b[99][nb];
char  name[99][12];
char  d[60],f1[40];
float sky[99],flu[99],white;
double addsky,ss;
double addgain;
int n1,n2,m;

float dd[99],saa[99],gain[99],thr;
float s61=6.;
float s62=6.;

float xmedian(a,m)
float *a; int m;
{
  int i,j; float x;
  for(i=0;i<m-1;i++)for(j=i+1;j<m;j++)if(a[i]<a[j]){
    x=a[i]; a[i]=a[j]; a[j]=x;
  }
  j=m/2; x=a[j];
  if(m%2==0)x=(a[j-1]+a[j])*0.5;
  return(x);
}

main(int ac,char **av)
{
  int i,j,k,jj,kk,l,ip=0;
  double xx,yy;
  if(ac<3){
    printf("\n\t******* combine q*.fit (from qz_9) ***********\n");
    printf("\n\tUsage: qcomb batchfile outfits\n");
    printf("\n\t       qcomb 1.1 aa.fit\n\n"); 
    exit(0);
  }
  fp1=fopen(av[1],"r");
  if(fp1==0){ printf("%s not found!\n",av[1]); exit(0); }
l10:
  fgets(d,60,fp1); if(feof(fp1))goto l20;
  k=strlen(d)-1; d[k]=0;
  fp[ip]=fopen(d,"rb");
  fread(h,72,80,fp[ip]);
  sscanf(&h[29][70],"%f",&flu[ip]);  if(flu[ip]<0.)flu[ip]=-flu[ip];
  sscanf(&h[32][12],"%f",&sky[ip]);
  d[12]=0;  strcpy(name[ip],&d[1]);
// read gain
  sscanf(&h[31][10],"%f %f %f %f",&saa[0],&saa[1],&saa[2],&saa[3]);
  thr=0.; for(i=0;i<4;i++)thr+=saa[i]; gain[ip]=thr*.25;
  ip++;
  if(ip!=99) goto l10;
    else printf(" only < 99 files canbe combine !\n"); 
l20:
  fclose(fp1);
//  for(i=0;i<ip;i++)printf("%2d %f %f\n",i+1,sky[i],flu[i]);
  sscanf(&h[3][12],"%d",&n1);
  sscanf(&h[4][12],"%d",&n2);
/*
        do 216 i=1,m
        dd(i)=sqrt(white(i)/g(i))
216     s(i)=s62*dd(i)/scale(i)
        sigma=xmedian(dd,m)
*/
  for(i=0;i<ip;i++){
    dd[i] =sqrt(sky[i]/gain[i]);
    saa[i]=s62*dd[i]/flu[i];
  } thr=xmedian(dd,ip);

  printf("%d files, %d*%d  thresh:%f\n",ip,n1,n2,thr);

  m=n1*n2;  j=jj=0; addsky=ss=0.;
                    addgain=0.;
  for(i=0;i<m;i++)a[i]=-9999.;
l30:
  k=m-j; if(k>nb)k=nb; if(k<=0)goto l40;
  if(jj%10==0){ printf("."); fflush(stdout); }
//  printf("%d %d\n",j,k); 
  for(kk=0;kk<ip;kk++){ fread(b[kk],4,nb,fp[kk]); swap4(b[kk],4*nb); }
  for(i=0;i<k;i++){
//allc(d[],white[],scale[],m,sigma,s[],s61,s50,g[])
//     dd  sky     flu    ip  thr  saa    6    gain
    for(kk=0;kk<ip;kk++)dd[kk]=b[kk][i];
    allc(dd,sky,flu,ip,thr,saa,s61,gain);     // if delete, dd[]=0;

    xx=yy=0.;
    for(kk=0;kk<ip;kk++)if(dd[kk]!=0.){
      xx+=dd[kk]-sky[kk];      yy+=flu[kk];
      addsky+=sky[kk]*flu[kk]; ss+=flu[kk];
      addgain+=gain[kk]*flu[kk];
    }
    if(yy!=0.)a[j+i]=xx/yy;
  }
  j+=k; jj++;
  goto l30;
l40:
  for(i=0;i<ip;i++)fclose(fp[i]);
  white=addsky/ss;
  thr=addgain/ss;                              // average gain
  printf("white: %f  gain: %f\n",white,thr);
  sprintf(&h[32][0],"SKYADU  =         %12.3f ",white);  h[32][31]='/';
                    for(i= 0;i<80;i++)h[7][i]=32;
                    for(i=10;i<30;i++)h[9][i]=32;
  for(j=30;j<32;j++)for(i= 0;i<80;i++)h[j][i]=32;
  for(j=32;j<34;j++)for(i=50;i<80;i++)h[j][i]=32;
  for(i=0;i<m;i++){ if(a[i]==-9999.)a[i]=0.; else a[i]+=white; }
  for(k=0;k<ip;k++){
    i=(k/4)+1; j=(k%4)*12+32;
    for(l=0;l<11;l++)h[i][j+l]=name[k][l];
  }
  sprintf(&h[0][31],"/ total files:%4d (de_comos)",ip);  h[0][60]=32;

  sscanf(name[0],"%d",&l);
  jd2date(l+1,&i,&j,&k);
  sprintf(h[8], "DATE-OBS=%4d,%02d,%02d ",i,j,k); 
  sscanf(name[ip-1],"%d",&l);
  jd2date(l+1,&i,&j,&k); sprintf(&h[8][20],"~%4d,%02d,%02d",i,j,k);
  h[8][31]='/';

  strcpy(f1,av[2]);
  fp1=fopen(f1,"wb");  fwrite(h,72,80,fp1);
  swap4(a,m*4); fwrite(a,m,4,fp1);  fclose(fp1);
  printf("output: %s\n",f1);
  sprintf(d,"c9 %s",f1); system(d);
}

allc(dd,sky,flu,ip,thr,saa,s61,gain)     // if delete, dd[]=0;
float *dd,*sky,*flu,thr,*saa,s61,*gain;
int   ip;
{
  int i,j,k,u[99];
  float d1[99],d2[99],x;
// delete bad & moveto
  for(i=k=0;i<ip;i++)if(dd[i]!=0.){
    if(dd[i]<sky[i]/2.)dd[i]=0.;           // delete dead point
    else { d2[k]=d1[k]=(dd[i]-sky[i])/flu[i]; u[k++]=i; }
  }
  if(k<3)return;                           // not enough
  x=xmedian(d2,k);
  if(x>thr){                 // star
    if(d2[0]<s61*x)return;
    for(i=0;i<k;i++)if(d1[i]==d2[0])dd[u[i]]=0.;  
  } else  {                  // background
    for(i=0;i<k;i++)
    if(d1[i]==d2[0] && d1[i]>saa[u[i]])dd[u[i]]=0.;
  }
}

/*
        do 20 i=1,m
20      if(d(i).gt.bad)d1(i)=(d(i)-white(i))/scale(i)  !ne
...
100     do 110 i=1,m
110     d2(i)=d1(i)
        x=xmedian(d2,m)
        if(x.gt.sigma)then              ! star
          if(d2(1).lt.s61*x)goto 200
          do 120 i=1,m
120       if(d1(i).eq.d2(1))d1(i)=x
        else                            ! background
          do 130 i=1,m
130       if( d1(i).eq.d2(1) .and. d1(i).gt.s(i) )d1(i)=x
        endif
*/

int mon[12]={31,28,31,30,31,30,31,31,30,31,30,31};
jd2date(int jd4,int *y,int *m,int *d)
{
  int iy,im,id,k;
  k=jd4; if(k<9354)k+=10000;
  for(iy=1994;iy<=2021;iy++){
    mon[1]=28; if(iy%4==0)mon[1]=29;
    for(im=0;im<12;im++)for(id=1;id<=mon[im];id++){
      if(k==jd2(iy,im+1,id)){ im++;
//        printf("%d ---> %02d %02d %02d\n",k-10000,iy,im,id);
        *y=iy; *m=im; *d=id; return;
      }
    }
  }
}

jd2(int year,int im,int id)
{
  int i,j,iy=year-1900;
  i=(im+9)*0.09; i=(i+iy)*1.75+0.01;
  j=30.56*im;  j=(iy-50)*367+id+j-i;
  return(j-6661);
}
