#include <stdio.h>
#define bok  48.
#define n1 8640
#define n2 8200
FILE *fp2,*fp3,*fp4;
char b[220];
char c1[14],c2[14],head[72][80];
double a8[8],b8[8],pi,cx,cy;
  
main(ac,av)
int ac; char *av[];
{
  int i,j,k;
  char f1[60],f2[60],f3[60],f4[60];
  double dx,dy,alpha,delta;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
    
  if(ac<2){ printf("usltocoo a0001\n\n"); exit(0); }

  strcpy(f1,av[1]); k=nindex(f1,"."); if(k>0)f1[k]=0;
  strcpy(f2,f1); strcat(f2,".fit");
  strcpy(f3,f1); strcat(f3,".co2");
  strcpy(f4,f1); strcat(f4,".usl");
  fp2=fopen(f2,"rb"); if(fp2==0){ printf("%s not found!\n",f2); exit(0); }
    fread(head,72,80,fp2);
    k=indexpos(head,"A81     ",72);
    if(k==72){ printf("%s not coordinating!\n",f2); exit(0); }
    for(i=0;i<8;i++)sscanf(&head[k+i][10],"%lf",&a8[i]);
    fclose(fp2); xytoad(a8,b8);

  toms2(a8[6]/cx,c1,1); toms2(a8[7]/cy,c2,0);
  sprintf(b,"usl %s %s 65.4 %s 24.0 !",c1,c2,f4);
  system(b);

  fp3=fopen(f3,"w"); 
  fp4=fopen(f4,"r");
l10:
  fgets(b,220,fp4); if(feof(fp4))goto l20;
  if(b[0]=='#')goto l10;
  sscanf(b,"%d",&k);
  b[18]=b[31]=0;
  chs(&b[6],&alpha,1); chs(&b[19],&delta,0);
  rad_xy(a8[6],a8[7],alpha,delta,&dx,&dy,1,0);
//  printf("%s %s %lf %lf  %lf %lf\n",b,&b[19], alpha,delta, dx,dy);
  if(dx < 10. || dy < 10.)goto l10;
  if(dx>n1-10 || dy>n2-10)goto l10;
  fprintf(fp3,"%6d %9.3lf %9.3lf\n",k,dx,dy);
  goto l10; 
l20:
  fclose(fp3); fclose(fp4);
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

