#include <stdio.h>
#include <math.h>
// *.fit
char head[72][80];
double a8[8],b8[8];
#define bok 48.
// SL array
#define ns  20000                         // SL all data in 31'
double sx[ns],sy[ns];                     // ra,  de
int    si1[ns],si2[ns];                   // usl_num
float  sf1[ns],sf2[ns],sf3[ns],sf4[ns];   // mag
float  apm[ns],ape[ns];                   // ap: mag+err
int    ks[ns];                            // our number
// our
#define os   4000
double ox[os],oy[os];
float  o[os][13];            // 13
short  om[os],bp[os];
int   kk[os];                // kk[] keep SL_num
// common
#define sig2   1.0           // dx*dx+dy*dy
double cx,cy,pi,dc;
char c1[14],c2[14];
FILE *fp,*fp1,*fp2,*fp3,*fp4;
#define n1  4096
#define n2  4032
char bad1[n2][n1],bad2[n2][n1],bad3[n2][n1],bad4[n2][n1];
int n,ccd;
main(int ac,char **av)
{
  int    i,j,k,l,m,ip;
  double xx,yy,zz,sig;
  float  dx,dy,zx,zy,t0,t1,f0,x[8],y[8];
  char   a[80],b[128],f1[20],f2[20],f3[20],f4[20],c,d[183];    //d_177
  float  seeing;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  if(ac<2){ printf("\n\t*** add SL_u(psf,model) to our cat ****\n");
            printf("\n\t                   jiang 2011,5,5\n");
            printf("\n\tusl_chart: field 31'  mag_limit 27m\n");
            printf("\n\tp*.cat ---> r*.cat (add bad_pixel mark)\n");
            printf("\n\tUsage: vm !\n\n");
            exit(0);
  }
// read bad_pixel table
  readbad(bad1,1); readbad(bad2,2); readbad(bad3,3); readbad(bad4,4);
// NOTICE  x-1,y-1 == bad[y][x];
  system("ls p*.cat >vm.tmp");
  fp=fopen("vm.tmp","r");
l00:
  fgets(f1,20,fp); if(feof(fp)) exit(0);
  k=strlen(f1); f1[k-1]=0;
  strcpy(f2,f1); f2[0]='r';   
  strcpy(f3,f1); k=strlen(f1); f3[k-3]='f'; f3[k-2]='i'; f3[k-1]='t';
  strcpy(f4,f1);               f4[k-3]='u'; f4[k-2]='s'; f4[k-1]='l';
  fp3=fopen(f3,"rb"); fread(head,72,80,fp3); fclose(fp3);
                               f3[k-3]='a'; f3[k-2]='p'; f3[k-1]=0;
  fp2=fopen(f2,"w");           // write r*.cat
  k=indexpos(head,"A81     ",72);
  for(i=0;i<8;i++)sscanf(&head[k+i][10],"%lf",&a8[i]);
  k=indexpos(head,"SEEING  ",72);
  sscanf(&head[k][10],"%f",&seeing);

// our  p*.cat
  fp1=fopen(f1,"r");
  n=0;
  fgets(b,128,fp1);   fprintf(fp2,"%s",b);
  fgets(b,128,fp1);   fprintf(fp2,"%s",b);  
  chs(&b[67],&dc); dc=cos(dc*cy)*54000.; 

  for(i=0;i<9;i++){ fgets(b,128,fp1);   fprintf(fp2,"%s",b); }
  fgets(b,128,fp1); fprintf(fp2,"# 1 bad_pixel     c1    (* 10sigma, & 5sigma)\n");
  for(i=2;i<=9;i++){ fgets(b,128,fp1);  fprintf(fp2,"%s",b); }
  fprintf(fp2,"#10 DA0_phot      f7.3\n");
  fprintf(fp2,"#11 DAO_phot_err  f6.3\n");
  for(i=10;i<=17;i++){ fgets(b,128,fp1); b[2]+=2;  fprintf(fp2,"%s",b); }
  fprintf(fp2,"#20 SL_number     c20\n");
  fprintf(fp2,"#21 SL_u_psf      f7.3\n");
  fprintf(fp2,"#22 SL_u_psf_err  f6.3\n");
  fprintf(fp2,"#23 SL_u_model    f7.3\n");
  fprintf(fp2,"#24 SL_u_model_er f6.3\n");

// readin p*.cat
  fp1=fopen(f1,"r");           // read  p*.cat
l30:       
  fgets(b,128,fp1); if(feof(fp1))goto l40;
  if(b[0]=='#')fprintf(fp2,"%s",b);
  if(b[0]=='#' || b[82]=='9')goto l30;
  chs(&b[5],&ox[n]); chs(&b[18],&oy[n]);
  sscanf(&b[31],"%f %f",&o[n][0],&o[n][1]);              // x.y
  if(b[51]!=32)sscanf(&b[47],"%f %f %f",&o[n][2],&o[n][3],&o[n][4]);
  else o[n][2]=o[n][3]=o[n][4]=0.;
  sscanf(&b[68],"%f %f %f %f %f %f %f %f %d", &o[n][5],&o[n][6],&o[n][7],
                 &o[n][8],&o[n][9],&o[n][10],&o[n][11],&o[n][12],&om[n]);
  n++;
  goto l30;
l40:
  fclose(fp1);

// readin sl
  fp4=fopen(f4,"r");           // read  p*.usl
  m=0;
l10:
  fgets(d,183,fp4); if(feof(fp4))goto l20;
  if(d[0]=='#')goto l10;
  sscanf(&d[32],"%10d%9d %f %f %f %f",
    &si1[m],&si2[m],&sf1[m],&sf2[m],&sf3[m],&sf4[m]);
  chs(&d[6],&sx[m]); chs(&d[19],&sy[m]); m++; if(m==ns)m--;
  goto l10;
l20:
  fclose(fp4);

// match
  ip=0;
l50:
  t0=t1=0.; k=0;
  for(j=l=0;j<n;j++){
    kk[j]=-1; sig=sig2; 
    for(i=0;i<m;i++){
      if(sf1[i]>24.)continue;               // faint to 24, not match
      yy=sy[i]-oy[j]; yy*=3600.; if(yy>1.)break; 
      zy=yy; yy*=yy; if(yy>sig)continue;
      xx=sx[i]-ox[j]; if(xx> 12.)xx-=24.; if(xx<-12.)xx+=24.;
      xx=xx*dc; zx=xx; xx*=xx;
      zz=xx+yy; if(zz<sig){ sig=zz; kk[j]=i; dx=zx; dy=zy; }	    
    }
    if(kk[j]!=-1){ l++; t0+=dx; t1+=dy; }
  }
  t0/=n; t1/=n;
  printf("%s matched: %d/%d shift: %6.3f %6.3f\n",f1,l,n,t0,t1);
  if(ip++<1){
    for(i=0;i<n;i++){ ox[i]+=t0/dc; oy[i]+=t1/3600.; }
    goto l50;
  }

// readin ap_data
  for(i=0;i<m;i++){ ks[i]=0; apm[i]=ape[i]=0.; }
  fp3=fopen(f3,"r");           // read  p*.ap
  fgets(d,180,fp3);  fgets(d,180,fp3); fgets(d,180,fp3);  
  fgets(d,180,fp3);
l05:
  fgets(d,180,fp3);  if(feof(fp3))goto l06;
  sscanf(d,"%d",&k);  k--;
  sscanf(&d[27],"%f %f %f %f %f %f %f %f",           // 5~12
    &x[0],&x[1],&x[2],&x[3],&x[4],&x[5],&x[6],&x[7]);
  fgets(d,180,fp3);  
  sscanf(&d[27],"%f %f %f %f %f %f %f %f",
    &y[0],&y[1],&y[2],&y[3],&y[4],&y[5],&y[6],&y[7]);
  fgets(d,180,fp3);  
  l=23.5-x[0]*1.8/seeing;
  if(l<5)l=5;  if(l>12)l=12;  l-=5;
  apm[k]=x[l]; ape[k]=y[l];  
  goto l05;
l06:
  fclose(fp3);

  sortd2(ox,oy,o,om,kk,n);                 // ours, sorted

// put bad_pixel mark
  k=strlen(f1); ccd=f1[k-5]-48; 
  if(ccd==1)putmark(bad1,n);
  if(ccd==2)putmark(bad2,n);
  if(ccd==3)putmark(bad3,n);
  if(ccd==4)putmark(bad4,n);

// output r*.cat
  for(i=0;i<n;i++){
    k=kk[i];  t0=t1=0.;
    if(k!=-1){ ox[i]=sx[k]; oy[i]=sy[k];  t0=apm[k]; t1=ape[k]; }
    toms2(ox[i],c1,1); toms2(oy[i],c2,0);
    c=32; if(bp[i]==10)c='*'; if(bp[i]==5)c='&';
    for(j=0;j<180;j++)d[j]=32;
    sprintf(d,"%c%s %s %7.2f %7.2f",c,c1,c2,o[i][0],o[i][1]); d[43]=32;
    if(o[i][2]!=0.)sprintf(&d[43],"%8.2f%7.3f%6.3f",o[i][2],o[i][3],o[i][4]);
    if(o[i][5]<99.){
    sprintf(&d[64],"%6.2f%7.3f%6.3f%8.2f%7.3f%6.3f%5.2f%7.2f%5.2f%6.1f%3d",
    o[i][5],t0,t1,o[i][6],o[i][7],o[i][8],
    o[i][9],o[i][10],o[i][11],o[i][12],om[i]);
    } else { d[64]=32;
    sprintf(&d[70],"%7.3f%6.3f%8.2f%7.3f%6.3f%5.2f%7.2f%5.2f%6.1f%3d",
    t0,t1,o[i][6],o[i][7],o[i][8],
    o[i][9],o[i][10],o[i][11],o[i][12],om[i]);
    }
    if(k!=-1){  // add SL data
      sprintf(&d[130]," %10d%09d %6.3f%6.3f%7.3f%6.3f",
             si1[k],si2[k],sf1[k],sf2[k],sf3[k],sf4[k]);
    }
    fprintf(fp2,"%s\n",d);
  }

// append sl data
  xytoad(a8,b8);
  for(i=0;i<n;i++)if(kk[i]!=-1)ks[kk[i]]=i+1;
  for(i=0;i<m;i++)if(ks[i]==0){
    rad_xy(a8[6],a8[7],sx[i],sy[i],&xx,&yy);
    if(xx<10. || xx>n1-10.)continue;
    if(yy<10. || yy>n2-10.)continue;
    if(ccd==4)if(xx<n1/2-10. || yy>n2/2-10.)continue;
    toms2(sx[i],c1,1); toms2(sy[i],c2,0);
    if(ccd==1)k=amark(bad1,xx,yy);
    if(ccd==2)k=amark(bad2,xx,yy);
    if(ccd==3)k=amark(bad3,xx,yy);
    if(ccd==4)k=amark(bad4,xx,yy);
    c=32; if(k==10)c='*'; if(k==5)c='&';
    fprintf(fp2,"%c%s %s%8.2lf%8.2lf                           ",c,c1,c2,xx,yy);
    fprintf(fp2,"%7.3f%6.3f                                   ",apm[i],ape[i]);
    fprintf(fp2,"             %10d%09d%7.3f%6.3f%7.3f%6.3f\n",
        si1[i],si2[i],sf1[i],sf2[i],sf3[i],sf4[i]);
  }
  fclose(fp2);

  goto l00;
}  

int amark(bad,x,y)
char bad[n2][n1]; 
double x,y;
{
  int i,j,m,ix,iy,r=10;
  // should +0.5 round, bad1[][] is 1 diff coord. so -0.5
  for(j=-r;j<=r;j++)for(i=-r;i<=r;i++){
    if(j*j+i*i>r*r)continue;
    ix=x+i-0.5; iy=y+j-0.5;
    if(bad[iy][ix]){ m=bad[iy][ix]; if(m==10)return(m); }
  }
  return(m);
}

putmark(bad,n)
char bad[n2][n1]; int n;
{
  int i,j,k,m,ix,iy,r=10;
  // should +0.5 round, bad1[][] is 1 diff coord. so -0.5
  for(k=0;k<n;k++){ m=0;
    for(j=-r;j<=r;j++)for(i=-r;i<=r;i++){
      if(j*j+i*i>r*r)continue;
      ix=o[k][0]+i-0.5; iy=o[k][1]+j-0.5;
      if(bad[iy][ix]){ m=bad[iy][ix]; if(m==10)goto l10; }
    }
l10:
    bp[k]=m;
  }
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[128];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

sortd2(x,y,o,om,ok,n)
double *x,*y; float o[][13]; short *om; int *ok,n;
{
  int i,j,k=2,ii,ifin;
  double xx,yy;
  float  oo[13];
  short  mm;
  int kk,l;
  while(k<n)k*=2;
  k=(3*k)/4-1; if(n<k)k=n;
l20:
  k/=2;        ifin=n-k;
  for(ii=0;ii<ifin;ii++){
    i=ii;      j=i+k;
    if(y[i]<=y[j])continue;
    xx = x[j];   yy= y[j];   mm=om[j];  kk=ok[j];
    for(l=0;l<13;l++)oo[l]=o[j][l];
l40:
    x[j]= x[i];  y[j]= y[i]; om[j]=om[i]; ok[j]=ok[i];
    for(l=0;l<13;l++)o[j][l]=o[i][l];
    j=i;       i-=k;
    if(i<0)goto l60;
    if(y[i]>yy)goto l40;
l60:
    x[j]=xx;     y[j]=yy;    om[j]=mm;    ok[j]=kk;
    for(l=0;l<13;l++)o[j][l]=oo[l];
  }
  if(k>1)goto l20;
}

readbad(a,m)
char a[n2][n1]; int m;
{
  int i,j,k;
  char f1[60];
  sprintf(f1,"/line3/uband-data/cat/ubadpixel/ubad_%d.fit",m);
  fp=fopen(f1,"rb"); 
  if(fp==0){ printf("%s not found!\n\n",f1);
    sprintf(f1,"ubad_%d.fit",m);
    fp=fopen(f1,"rb");
    if(fp==0)exit(0);
  }
  fseek(fp,36*80,0); fread(a,n1,n2,fp); fclose(fp);
}

xy_rad(ac,dc,x,y,ra,de)
double ac,dc,x,y,*ra,*de;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  tmp=1.+bok*(xi*xi+xn*xn);
  for(i=0;i<4;i++){
    x1=xi/tmp; y1=xn/tmp;
    tmp=tan(dc);  tmp1=1.-y1*tmp;
    r1=atan(x1/cos(dc)/tmp1);
    d1=atan((y1+tmp)*cos(r1)/tmp1);
    r1+=ac;
    tmp=atan(tan(d1)/cos(r1-ac));
    x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
    y1=tan(tmp-dc);
    tmp=1.+bok*(x1*x1+y1*y1);
  }
  xi/=tmp; xn/=tmp;
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  *ra/=cx; *de/=cy;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

rad_xy(ac,dc,ra,de,x,y)
double ac,dc,ra,de,*x,*y;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  tmp=1.+bok*(xi*xi+xn*xn);
  xi*=tmp; xn*=tmp;
  *x=b8[0]*xi+b8[2]*xn+b8[4];
  *y=b8[1]*xi+b8[3]*xn+b8[5];
}
