#include <stdio.h>
#include <math.h>
char c1[14],c2[14];
double a8[8],b8[8],pi,cx,cy;
#define bok 48.
//  ra: 1.0703  =8487pixel
// dec: 1.0179  =8072pixel
FILE *fp,*fp1;
float scale=0.454;
int    n1,n2,area,m1,m2;
char a[60];
double rc,dc,hs2,alpha,delta;
main(int ac, char **av)
{
  int i,j,k,ip=0;
  double x,y,x1,y1,xx,yy;
  float aa[5],dd[5],zx,zy,z1,z2;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  if(ac<5){ printf("\n\t****** guess n1,n2 *****\n");
            printf("\n\tuse s82nfield.txt\n");
            printf("\n\tUsage: get_area n2 n1 (8072,8487)\n");
            printf("\n\tEx:    get_area 8200 8640 1 1874\n\n");
            exit(0);
          }
  sscanf(av[1],"%d",&n2);
  sscanf(av[2],"%d",&n1);
  sscanf(av[3],"%d",&m1);
  sscanf(av[4],"%d",&m2);

// i=0;     j=1;                pgbegin_(&i,"/xw",&j,&j,3);
// zx=21.5; z1=20.5; zy=-11; z2=-8;  pgenv_(&zx,&z1,&zy,&z2,&i,&i);

  fp=fopen("area.txt","r");
l10: ip++;
  if(m1>ip)goto l10; if(m2<ip)goto l20;
  fgets(a,60,fp); if(feof(fp))goto l20;
  sscanf(a,"%lf %lf %d",&x,&y,&area);
  toms2(x/15.,c1,1); toms2(y,c2,0);
  rc=x*cy; dc=y*cy; a8[6]=rc; a8[7]=dc;
  hs2=(3600.*180./pi)/scale;
  b8[0]=-hs2; b8[1]=b8[2]=0; b8[3]=-b8[0]; b8[4]=(n1+1)/2.; b8[5]=(n2+1)/2.;
  xytoad(b8,a8);
  x=(n1+1)/2.; y=(n2+1)/2.;  xy_rad(rc,dc,x,y,&alpha,&delta,1,0);
  toms2(alpha,c1,1); toms2(delta,c2,0);
  printf("z_9 a%04d.fit 0.454 %s %s %d %d 0.6\n",area,c1,c2,n1,n2);
  goto l10;
l20:
  fclose(fp);
//  pgend_();
}   
   
chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

rad_xy(ac,dc,ra,de,x,y)
double ac,dc,ra,de,*x,*y;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  tmp=1.+bok*(xi*xi+xn*xn);
  xi*=tmp; xn*=tmp;
  *x=b8[0]*xi+b8[2]*xn+b8[4];
  *y=b8[1]*xi+b8[3]*xn+b8[5];
}

xy_rad(ac,dc,x,y,ra,de)
double ac,dc,x,y,*ra,*de;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  tmp=1.+bok*(xi*xi+xn*xn);
  for(i=0;i<4;i++){
    x1=xi/tmp; y1=xn/tmp;
    tmp=tan(dc);  tmp1=1.-y1*tmp;
    r1=atan(x1/cos(dc)/tmp1);
    d1=atan((y1+tmp)*cos(r1)/tmp1);
    r1+=ac;
    tmp=atan(tan(d1)/cos(r1-ac));
    x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
    y1=tan(tmp-dc);
    tmp=1.+bok*(x1*x1+y1*y1);
  }
  xi/=tmp; xn/=tmp;
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  *ra/=cx; *de/=cy;
}
