#include <stdio.h>
#include <math.h>
#define n 90000             // *.ap stars
#define n1 8640
#define n2 8200
char  f1[60],f2[60],f3[60],d[140],d1[140], head[72][80];
float a_b[n2][n1], seeing[200], dummy[n], ux[961],uy[961];
FILE  *fp1,*fp2,*fp3;
float xm,xm2,x05,r2,xs2,x12, a4,af, seex,seeh;
int   mn,i15, ix,iy,i70;
double xs;
struct { int k; float x,y,m[10],sky,ss; } aaa,aa[n],a[n];

sortf12(i1,i2,m)
float *i1,*i2; int m;
{
  int i,j,k=2,l,ii,ifin;
  float    ii1,ii2;
  while(k<m)k*=2;
  k=(3*k)/4-1; if(m<k)k=m;
l20:
  k/=2;        ifin=m-k;
  for(ii=0;ii<ifin;ii++){
    i=ii;      j=i+k;
    if(i1[i]<=i1[j])continue;
    ii1=i1[j];     ii2=i2[j];
l40:
    i1[j]=i1[i]; i2[j]=i2[i];
    j=i;       i-=k;
    if(i<0)goto l60;
    if(i1[i]>ii)goto l40;
l60:
    i1[j]=ii1;     i2[j]=ii2;
  }
  if(k>1)goto l20;
}

float wing(x,y,see,r2)
float x,y,see,r2;
{
  float az,z=0.;
  int i,j=0,k=20,i1,i2,j1,j2;
  i1=x-0.5; i2=y-0.5;                       // fortran +, C -
  for(j1=i1-15;j1<=i1+15;j1++)for(j2=i2-15;j2<=i2+15;j2++){
    uy[j]=a_b[j2][j1];
    ux[j]=sqrt((j1-x+1)*(j1-x+1)+(j2-y+1)*(j2-y+1));
    j++;
  }
  sortf12(ux,uy,961);
  for(i=0;i<961;i++)if(ux[i]>see)break;
  for(j=i;j<=i+r2;j++){
    az=uy[j]-uy[j+1]; if(az<0.)az=-az;
    z+=az/ux[j];
    k--; if(k==0)k=1;
  }
  return(z);
}

sort1(float *a,int m)
{
  int i,j; float z;
  for(i=0;i<m-1;i++)for(j=i+1;j<m;j++)if(a[i]>a[j]){
    z=a[i]; a[i]=a[j]; a[j]=z;
  }
}

float see(map,x,y,sky)
float map[n2][n1],x,y,sky;
{
  int i,j,k,ix,iy,m,b[113];
  float z,s1,s2;
  ix=x-0.5; iy=y-0.5;
  for(j=0,i=ix-14;i<=ix+14;i++,j+=4){
    z=0.; for(k=-2;k<=2;k++)z+=map[iy+k][i]-sky; b[j]=z; }
  for(j=0;j<112;j+=4)b[j+2]=(b[j]+b[j+4])/2.+0.5;
  for(j=0;j<112;j+=2)b[j+1]=(b[j]+b[j+2])/2.+0.5;
  for(j=0;j<112;j++)if(b[j]<0)b[j]=0;
  histat(b,&z,&s1,112);
  for(j=0,i=iy-14;i<=iy+14;i++,j+=4){
    z=0.; for(k=-2;k<=2;k++)z+=map[i][ix+k]-sky; b[j]=z; }
  for(j=0;j<112;j+=4)b[j+2]=(b[j]+b[j+4])/2.+0.5;
  for(j=0;j<112;j+=2)b[j+1]=(b[j]+b[j+2])/2.+0.5;
  for(j=0;j<112;j++)if(b[j]<0)b[j]=0;
  histat(b,&z,&s2,112);
  z=(s1+s2)/8.*2.355*0.454;
  return(z);
}

main(int ac, char **av)
{
  int i,j,k,m,l;
  float x,y,m0,m1,m2,m3,m4,m5,m6,m7,m8,m9,sky,ss;
  float z;

  if(ac<2){
    printf("\n\t ****** Dao_autopsf 4*4 for 8640*8200 (2012,2) *****\n");
    printf("\n\tUsage: u_psf94k file\n\n"); exit(0); 
  }
  strcpy(f1,av[1]); k=nindex(f1,"."); if(k>0)f1[k]=0;
  strcpy(f2,f1); strcat(f2,".fit");
  fp2=fopen(f2,"rb"); if(fp2==0){printf("%s not found!\n",f2); exit(0); }
  fread(head,72,80,fp2); fread(a_b,n1*n2,4,fp2); fclose(fp2);
  swap4(a_b,n1*n2*4);
 
  strcpy(f2,f1); strcat(f2,".ap");
  fp2=fopen(f2,"r"); if(fp2==0){printf("%s not found!\n",f2); exit(0); }

  for(i=0;i<3;i++)fgets(d,140,fp2);  i=0;
l29:
  fgets(d,140,fp2); if(feof(fp2))goto l28;
  fgets(d,140,fp2); fgets(d1,140,fp2);
  sscanf(d,"%d%f%f %f%f%f%f%f %f%f%f%f&f",&k,&x,&y,        
           &m0,&m1,&m2,&m3,&m4,&m5,&m6,&m7,&m8,&m9);     // 10/12
  sscanf(d1,"%f%f",&sky,&ss);                            // sky,
  if(i && y>z+n2/2)goto l28;                             // meet usl_data
  aa[i].m[0]=m0; aa[i].m[1]=m1; aa[i].m[2]=m2; aa[i].m[3]=m3; aa[i].m[4]=m4;  
  aa[i].m[5]=m5; aa[i].m[6]=m6; aa[i].m[7]=m7; aa[i].m[8]=m8; aa[i].m[9]=m9;  
  aa[i].k=k; aa[i].x=x; aa[i].y=y;               aa[i].sky=sky; aa[i].ss=ss;
  i++; z=y;
  goto l29;
l28:
  fclose(fp2); mn=i;

// get a suitable bright_mag star, for begin
  for(i=l=0;i<mn;i++){
    for(j=0;j<6;j++)if(aa[i].m[j]>90.)goto l910;
    dummy[l++]=aa[i].m[0];
l910: ;
  }
  sort1(dummy,l); l--; if(l>49)l=49;
  xm=dummy[49];
  printf("xm %f\n",xm);

// --------------------------
  i15=6;                                //  2~10   use how many apertures
  x05=0.;
  r2=225.;

l1001:                                  // LOOP HERE	
  for(m=0;m<mn;m++)a[m]=aa[m];
  printf("=====all_star: %d\n",m);

// delete >95 point, delete edge point 20 pixel
  for(i=l=0;i<m;i++){
    for(j=0;j<i15;j++)if(a[i].m[j]>90.)goto l10;
    if(a[i].x<20. || a[i].x>n1-20)goto l10;
    if(a[i].y<20. || a[i].y>n2-20)goto l10;
    a[l++]=a[i];
l10: ;
  }
  m=l;
  printf("af 4,9>90; >20 edge_star %d\n",m);

// get sky,s_sky
  xs=0.; for(i=0;i<m;i++)xs+=a[i].sky;  xs/=m;
  xm2=xm+x05;
  printf("mag,sky: %f %lf\n",xm2,xs);

  xs2=xs*1.1;
  for(i=l=0;i<m;i++){
    if(a[i].m[0]>xm2)continue;
    if(a[i].sky >xs2)continue;
    a[l++]=a[i];
  }
  m=l;
  printf("af xm2,sky>1.1: %d\n",m);

// delete galacy
  for(i=l=0;i<m;i++){
    a4=af=a[i].m[0]; 
    for(j=1;j<i15;j++){
      if(a[i].m[j]-af >0.1 || a4-a[i].m[j] >1.0)goto l310;
      af=a[i].m[j];
    }
    a[l++]=a[i];
l310: ;
  }  
  m=l;
  printf("af galaxy: %d\n",m);

// delete neibur star of remain   
l501:
  printf("r2=%f\n",r2);
  for(i=l=0;i<m;i++){
    x=a[i].x; y=a[i].y;
    for(j=0;j<m;j++){
      if(i==j)continue;
      z=(a[j].x-x)*(a[j].x-x)+(a[j].y-y)*(a[j].y-y);
      if(z<r2)goto l410;
    }
    a[l++]=a[i]; 
l410: ;
  }
  m=l;
  printf("af_neibur: %d\n",m);

// delete neibur stars
  for(i=l=0;i<m;i++){
    x=a[i].x; y=a[i].y;
    for(j=0;j<mn;j++){
      z=(a[j].x-x)*(a[j].x-x)+(a[j].y-y)*(a[j].y-y);
      if(z<0.0001)continue;             // is myself, 
      if(z<r2)goto l510;
    }
    a[l++]=a[i];
l510: ;
  }
  m=l;
  printf("af_neibur2: %d\n",m);

// delete bigger, too_small seeing
  if(m>=200)m=200;                            // if loop here
  for(i=0;i<m;i++){                           // not do seeing adjust
    y=see(a_b,a[i].x,a[i].y,a[i].sky);
    seeing[i]=a[i].ss=y;
  }
  sort1(seeing,m); x=seeing[m/2];
  seex=x;      seeh=seex*0.75;
  for(i=l=0;i<m;i++)if(a[i].ss<seex && a[i].ss>seeh)a[l++]=a[i];
  m=l;
  printf("af seeing: %d\n",m);

// bright star near
  x12=0.; for(i=0;i<m;i++)x12+=a[i].sky; x12/=m;
  x=0.;
  for(l=0;l<m;l++){
    ix=a[l].x+0.5; iy=a[l].y+0.5;
    z=0; i70=70;
    for(i=ix-i70;i<ix+i70;i++){
      if(i<0 || i>n1-1)continue;
      for(j=iy-i70;j<iy+i70;j++){
        if(j<0 || j>n2-1)continue;
	y=(i-ix)*(i-ix)+(j-iy)*(j-iy);
	if(y<225)continue;
	y=a_b[j][i]-x12;
	if(y>0.)z++;
      }
    }
    x+=z;
    dummy[l]=z;
  }
  x=x/m*1.2;
  for(i=l=0;i<m;i++){ if(dummy[i]>x)continue; a[l++]=a[i]; }
  m=l;
  printf("af bright_star near: %d\n",m);

// delete bad wing
  for(i=0;i<m;i++){ 
    y=wing(a[i].x,a[i].y,seex,r2,&y);
    dummy[i]=y*(a[i].m[0]-xm+10.)*0.01;
  }
  x12=1.1; x=0.;
  for(i=0;i<m;i++)x+=dummy[i];       x=x/m*x12;
  for(i=l=0;i<m;i++)if(dummy[i]<=x)a[l++]=a[i];
  m=l;
  printf("af bad_wing: %d\n",m);

  if(x05<0.9 && m<=20){ x05+=0.5; i15--; r2=100.; goto l1001; }

  for(i=0;i<m-1;i++)for(j=i+1;j<m;j++)if(a[i].m[0]>a[j].m[0]){
    aaa=a[i]; a[i]=a[j]; a[j]=aaa; }

  strcpy(f3,f1); strcat(f3,".lst");
  fp3=fopen(f3,"w");
  if(m>30)m=30;
  for(i=0;i<m;i++){
    printf("%5d%9.1f%9.1f%9.2f%9.1f%9.2f\n",
    a[i].k,a[i].x,a[i].y,a[i].m[0],a[i].sky,a[i].ss);
    fprintf(fp3,"%5d%9.1f%9.1f%9.2f%9.1f%9.2f\n",
    a[i].k,a[i].x,a[i].y,a[i].m[0],a[i].sky,a[i].ss);
  }
  fclose(fp3);
  printf("%d\n",m);
}
